Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #286

Slow file content probing
April 28, 2013 19:27 - Anonymous

Status: Closed Start date: April 28, 2013
Priority: Minor Due date:

Assignee: % Done: 100%
Category: core Estimated time: 0.00 hour
Target version: 3.4

Affects version: 3.34

Description

Hello all. I'm using v3.3.4 in Debian Wheezy.
| like to keep my audio files without filename extensions.

Audacious reads and plays extensionless mp3 files perfectly quickly, displays immediately, and is able to get all the metadata (from
tag and otherwise, including things like bitrate) when you open song info for a track.

It plays extensionless ogg and flac files immediately, but the player hangs about a minute (especially on flac files) before displaying
anything in the GTK interface, and also does not give album, track number or bitrate. Strangely it does give the title, artist, comment
and year, even when the folder names don't include year.

History

#1 - April 29, 2013 00:03 - John Lindgren

Please attach an example file; otherwise there's no way for anyone to help you.

#2 - April 29, 2013 01:07 - Anonymous
- File rrob.ogg added

okay, for your testing pleasure, here's a clip of Rose Royce's "Ooh Boy"

#3 - April 29, 2013 04:34 - John Lindgren

See if these commits help:
https://github.com/audacious-media-player/audacious/commit/c6d076aad9fc9fc2551ed8e150a62d6e60570628

https://github.com/audacious-media-player/audacious-plugins/commit/a3230bbc3b1{500006511e6f402915819d22e2a3

| couldn't reproduce anything near a one-minute delay here, though.

#4 - April 29, 2013 06:10 - Anonymous
- File 07 AM.png added

sorry, i'm in over my head here. i don't know how to install those commits. unless it's easy enough to explain in a post i guess i'll just wait until it hits
the next release. i appreciate you looking at this. i was wondering though, aside from not being able to reproduce the long delays, were you able to
reproduce the behavior of not seeing all the vorbis tag info or bitrate info? the rrob.ogg file i included above contains:

Nominal bitrate: 256.000000 kb/s
Upper bitrate not set

Lower bitrate not set

User comments section follows...
TITLE=Ooh Boy

ARTIST=Rose Royce
ALBUM=In Full Bloom
TRACKNUMBER=03
https://github.com/audacious-media-player/audacious/commit/c6d076aad9fc9fc2551ed8e150a62d6e60570628
https://github.com/audacious-media-player/audacious-plugins/commit/a3230bbc3b1f500b06511e6f402915819d22e2a3

DATE=1977

COMMENT=test comment
Vorbis stream 1:

Total data length: 7931842 bytes
Playback length: 4m:16.506s
Average bitrate: 247.380455 kb/s

but when i remove the filename extension and play in Audacious | only see the attached image, no bitrate or tracknumber, and no album in song info

window but album "r" in the main window. the track is located in a folder called "r". also curious, if it's "Unknown sndfile", how is it able to know the
vorbis comment and year?

#5 - April 29, 2013 21:43 - Michael Schwendt

To Ryan:
You can run "audacious -V FILENAMEHERE" in your favourite terminal and observe what it does when it tries to recognise the file contents.
Depending on what input plug-ins are enabled, several of the plug-ins try to examine the file data, which takes some time. That's not the case when

the file extension is present and the .flac plugin is tried first. If the extension is missing, note that the "sndfile" plug-in (based on libsndfile) can handle
FLAC, too, and may play the file instead of the "flacng" plug-in.

#6 - May 01, 2013 01:09 - John Lindgren

The sndfile plugin was grabbing Ogg Vorbis files here without the .0ogg extension; that's why | lowered its priority.

#7 - May 01, 2013 21:33 - Michael Schwendt

Understood. | tried ext-less FLAC files here due to the original comment in the bug report. Quoting:
> but the player hangs about a minute (especially on flac files)

It doesn't hang so long, but displays "Buffering" for several seconds, and the sndfile plugin also took the FLAC files.

#8 - May 03, 2013 01:08 - John Lindgren

| cannot reproduce any noticeable delay here when playing a 10-minute FLAC file with no extension.

#9 - May 03, 2013 09:16 - Michael Schwendt

Here the MPG123 based madplug.so does a lot of vfs seeking, causing a noticable delay of several seconds. Full log:

http://mschwendt.fedorapeople.org/tmp/audacious—ext-less-flac-loading.log.gz

$ audacious -V flac

probe.c:65 [probe_func]: VFS: <0x22f6d00> seek to 0 from beginning

probe.c:65 [probe_func]: Trying MPG123 Plugin.

pluginenum.c:63 [plugin_load]: Loading plugin: /ust/lib64/audacious/Input/madplu
g.so.

Trying MPG123 Plugin.

mpg123.c:66 [aud_mpg123_init]: initializing mpg123 library

VFS: <0x22f6d00> size = 37995628

VFS: <0x22fa280> size = 37995628

VFS: <0x22f6d00> seek to 0 from end
VFS: <0x22fa280> seek to 0 from end
VFS: <0x22f6d00> tell = 37995628

VFS: <0x22fa280> tell = 37995628

VFS: <0x22f6d00> seek to -128 from end
VFS: <0x22fa280> seek to -128 from end

... thousands of times ...

VFS: <0x22fa280> seek to -3 from current

VFS: <0x22fa280> tell = 28901037

VFS: <0x22fa280> seek to -3460 from current

VFS: <0x22fa280> tell = 28901041

mpg123.c:122 [mpg123_probe_for_fd]: Probe error: A generic mpg123 error.
VFS: <0x22fa280> seek to 0 from beginning

probe.c:65 [probe_func]: Trying OpenPSF PSF1/PSF2 Decoder.

probe.c:65 [probe_func]: Trying Sndfile Plugin.

$ grep "VFS LOG|wc -I
70546

#10 - May 04, 2013 01:25 - John Lindgren

That should have been fixed by c6d076aa. Are you running Git master?

#11 - May 04, 2013 03:17 - John Lindgren

- Subject changed from slow response / fail to read metadata for certain files to Slow file content probing

#12 - May 09, 2013 01:05 - John Lindgren
- Category set to core

- Status changed from New to Closed

- Target version set to 3.4

- % Done changed from 0 to 100

I'm going to assume this is fixed until shown otherwise.

Files

rrob.ogg 798 KB April 29, 2013 Anonymous

07 AM.png 73.8 KB April 29, 2013 Anonymous
